﻿// Add special assembly references to be parsed by ACT here.  ACT will always add itself as a reference.
// Example:  (Keep the // commenting in actual use)  
// reference:System.dll
// reference:Microsoft.VisualBasic.dll

using System;
using Advanced_Combat_Tracker;
using System.Reflection;
using System.Windows.Forms;
using Microsoft.VisualBasic;

[assembly: AssemblyTitle("MiniJobStrPluginMod")]
[assembly: AssemblyFileVersion("1.4.0.0")]

namespace ACTv3Plugins
{
    public class MiniJobStrPluginMod : IActPluginV1
    {
        Label statusLabel;

        public void InitPlugin(TabPage pluginScreenSpace, Label pluginStatusText)
        {

            //JobName
            statusLabel = pluginStatusText;
            CombatantData.ExportVariables.Add(
                "jobname",
                new CombatantData.TextExportFormatter("jobname", "Job Name", "Character's job", (data, extra) =>
                {
                    string s = data.GetColumnByName("Job");
                    if (s == "")
                    {
                        return s = ("---");
                    }
                    else
                    {
                        return s;
                    }
                }));

            //job or Initials
            CombatantData.ExportVariables.Add(
                "J_or_I",
                new CombatantData.TextExportFormatter("J_or_I", "Job or Initials", "Initials of the owner or job", (data, extra) =>
                {
                    string s = data.GetColumnByName("Job");
                    if (s == "")
                    {
                        string s1 = data.GetColumnByName("Name");
                        if (System.Text.RegularExpressions.Regex.IsMatch(s1, @"\)$"))
                        {
                            System.Text.RegularExpressions.Regex r =
                                new System.Text.RegularExpressions.Regex(@".+([A-Z])[`a-z]+\s([A-Z]).+");
                            return s = r.Replace(s1, "$1.$2");
                        }
                        else
                        {
                            return s = ("---");
                        }
                    }
                    else
                    {
                        return s;
                    }
                }));

            //Name(No owner)
            CombatantData.ExportVariables.Add(
                "NameNo",
                new CombatantData.TextExportFormatter("NameNo", "Name(No owner)", "Delete the name of the owner from the name of the pet", (data, extra) =>
                {
                    string s = data.GetColumnByName("Name");
                    System.Text.RegularExpressions.Regex r =
                                new System.Text.RegularExpressions.Regex(@"\(.+\)");
                    return r.Replace(s, "").Trim();
                }));

            //Name(No owner)Hankaku
            CombatantData.ExportVariables.Add(
                "NameNoHan",
                new CombatantData.TextExportFormatter("NameNoHan", "Name(No owner)Hankaku", "Delete the name of the owner from the name of the pet", (data, extra) =>
                {
                    string s = Strings.StrConv(data.GetColumnByName("Name"), VbStrConv.Narrow, 0x411);
                    System.Text.RegularExpressions.Regex r =
                                new System.Text.RegularExpressions.Regex(@"\(.+\)");
                    return r.Replace(s, "").Trim();
                }));

            //ZoneName
            EncounterData.ExportVariables.Add(
                "ZoneName",
                new EncounterData.TextExportFormatter("ZoneName", "ZoneName", "Show the zone name", (data, SelectiveAllies, extra) =>
                {
                    return data.ZoneName;
                }));

            //ToHit%+
            CombatantData.ExportVariables.Add(
                "ToHit%+",
                new CombatantData.TextExportFormatter("ToHit%+", "ToHit%+", "The change to --- null", (data, extra) =>
                {
                    string s = data.GetColumnByName("ToHit%");
                    if (System.Text.RegularExpressions.Regex.IsMatch(s, @"\)$"))
                    {
                        return s = ("---");
                    }
                    else
                    {                     
                        return s;
                    }
                }));

            //ShortToHit%+
            CombatantData.ExportVariables.Add(
                "ShortToHit%+",
                new CombatantData.TextExportFormatter("ShortToHit%+", "ShortToHit%+", "The change to --- null", (data, extra) =>
                {
                    string s = data.GetColumnByName("ToHit%");
                    if (System.Text.RegularExpressions.Regex.IsMatch(s, @"\)$"))
                    {
                        return s = ("---");
                    }
                    else
                    {
                        s = System.Text.RegularExpressions.Regex.Replace(s, @"\.\d+$", "");
                        return s;
                    }
                }));

            //Parry
            statusLabel = pluginStatusText;
            CombatantData.ExportVariables.Add(
                "Parry%",
                new CombatantData.TextExportFormatter("Parry%", "Parry%", "Parry%", (data, extra) =>
                {
                    return data.GetColumnByName("ParryPct");
                }));

            //Block
            statusLabel = pluginStatusText;
            CombatantData.ExportVariables.Add(
                "Block%",
                new CombatantData.TextExportFormatter("Block%", "Block%", "Block%", (data, extra) =>
                {
                    return data.GetColumnByName("BlockPct");
                }));
            ActGlobals.oFormActMain.ValidateLists();
            statusLabel.Text = "Initialized.";
        }
        public void DeInitPlugin()
        {
            CombatantData.ExportVariables.Remove("jobname");
            CombatantData.ExportVariables.Remove("J_or_I");
            CombatantData.ExportVariables.Remove("NameNo");
            CombatantData.ExportVariables.Remove("NameNoHan");
            EncounterData.ExportVariables.Remove("ZoneName");
            CombatantData.ExportVariables.Remove("ToHit%+");
            CombatantData.ExportVariables.Remove("ShortToHit%+");
            CombatantData.ExportVariables.Remove("Parry%");
            CombatantData.ExportVariables.Remove("Block%");
            statusLabel.Text = "Deinitialized";
        }
    }
}